;compiler: avrasm
;Prehravac PCM WAV souboru z root adresare HDD/CF se souborovym systemem FAT16 (1.partition)
;posledni uprava: 4.8.2005
;dotazy na s.maslan@seznam.cz
;MCU - ATmega32
;pri frekvencich nad 16MHz naprogramovat fusebit CKOPT !!!!!!

	;vyber D/A prevodniku
	;1545 - TDA1545
	;1543 - TDA1543
	.equ	DAC=1545
	;1/rychlost rolovani nazvu po LCD, muze byt max 90
	.equ	NameRollSpeed=75
	;XTAL, idealni je 20MHz, ale na nizsi vzorkovaci frekvenci to pojede treba i na 10MHz 
	.equ	XTAL=16000000

	.include "m32def.inc"
	.dseg
BitVars:	.byte	1	;bitove promenne
MenuVars:	.byte	1	;bitove promenne pro menu adresare
LastComVars:	.byte	1	;bitove promenne obsahujici nektere informace u poslednich vykonanych operacich tlacitek
FAT1LBAadress:	.byte	4	;zacatek 1.FAT
RootLBAadress:	.byte	4	;zacatek root adresare
DataLBAadress:	.byte	4	;zacatek dat
SecPerCluster:	.byte	1	;sektoru na cluster
RootDirSectors:	.byte	1	;pocet sektoru root adresare
ButtonStack:	.byte	3	;neco pro tlacitka
IncDecPosKonst:	.byte	1	;konstanta pro posuv skladby
FolderN:	.byte	1	;pocet adresaru
FolderPTR:	.byte	1	;cislo aktualniho adresare
SongN:	.byte	1	;pocet skladeb
SongPTR:	.byte	1	;ukazatel na skladbu
SongLen:	.byte	2	;delka skladby v clusterech
SongLenBytes:	.byte	4	;delka skladby v bytech
SongPos:	.byte	2	;pozice v clusterech
SongFormat:	.byte	1	;format PCM (jen mono/stereo - bit 1)
SongNameString:	.byte	92	;nazev souboru
SongNameLen:	.byte	1	;delka nazvy (pocet znaku)
SongNamePos:	.byte	1	;aktualni ofset nazvu na LCD (pro rolovani)
SongNameRolMode:	.byte	1	;smer rolovani nazvu
SongNameDivider:	.byte	1	;delitel pro rychlost rolovani pri play
SongNameRSpeed:	.byte	1	;rychlost rolovani
SongNameDivStop:	.byte	2	;delitel pro rychlost rolovani pri STOP
FIFOptr:	.byte	4	;RD, WR ukazatel pro FIFO
	.equ	FIFOsize=1700	;delka = FIFOsize/(4*SampleRate[kHz]) [ms]
OutputFIFO:	.byte	FIFOsize	;vystupni FIFO
;!!!! velikost musi byt delitenla 4-mi a vetsi nez 1000, ale max tak 1700 aby zbylo na ostatni promenne a stack!!!!
	
	.cseg
	.org	$000	;inicializace
	rjmp	Init
	.org	$008	;preruseni timeru 2 pro cteni tlacidel
	jmp	CteniTlacitek
;************************************************************************************************
;preruseni play casovace - vezme data z FIFO registru z adresy RD a posle je na DAC
;************************************************************************************************
	.org	$014	;preruseni timeru 0 pro vystup FIFO registru
	;tento podprogram musi byt co nejkratsi, takze v dusledku optimalizace dost neprehledny :-)
	;!!! push/pop je nahrazeno in/out do nevyuzitych registru casovace 1 a jinde se s nimi nesmi manipulovat (usetri se 4 cykly :-)!!!
	out	ocr1bh,R16	;misto push
	out	ocr1bl,R30	;misto push
	in	R16,sreg	;misto push
	out	icr1h,R31	;misto push
	out	icr1l,R16	;misto push

	lds	R30,FIFOptr	;nacteni RD adresy
	lds	R31,FIFOptr+1

	;tady je treba vybrat cast kodu pro TDA1543(I2S) nebo TDA1545("japonsky standard" casove multiplexovany, doplnkovy tvar (standard jak noha - prakticky jde o I2S, kde je signal WS zpozden o 1 hodinovy cykl))
	.if	DAC==1545
	;generovani sbernice pro DAC TDA1545
	;PS.: nic nemazat - je to presne nacasovano a kratsi uz to byt nemuze
	;pro DAC TDA1545
	ld	R16,Z+
	out	spdr,R16	;high byte levy
	;15 cyklu pauza
	ldi	R16,5
ISPdel1:	dec	R16
	brne	ISPDel1
	;
	ld	R16,Z+
	out	spdr,R16	;low byte levy
	;pauza 15 cyklu
	ldi	R16,4
ISPdel2:	dec	R16
	brne	ISPdel2
	cpi	R30,low(OutputFIFO+FIFOsize-2)
	ldi	R16,high(OutputFIFO+FIFOsize-2)
	cpc	R31,R16
	;
	ld	R16,Z+
	sbi	portb,2	;negovat WS pin
	out	spdr,R16	;high byte pravy
	ld	R16,Z+
	;pauza 15 cyklu
	brne	NeKonec
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)
	rjmp	JoKonec
NeKonec:	nop
	nop
	nop
JoKOnec:	sts	FIFOptr,R30
	sts	FIFOptr+1,R31
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	;
	out	spdr,R16	;low byte pravy
	;pauza 15 cyklu
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	in	R31,icr1h	;misto pop
	in	R16,icr1l	;misto pop
	out	sreg,R16	;misto pop
	in	R16,ocr1bh	;misto pop
	in	R30,ocr1bl	;misto pop
	;
	cbi	portb,2	;negovat pin WS

	.else
	;generovani I2S pro DAC TDA1543
	;PS.: nic nemazat - je to presne nacasovano a kratsi uz to byt nemuze
	ld	R16,Z+
	out	spdr,R16
	;15 cyklu pauza
	ldi	R16,5
ISPdel1:	dec	R16
	brne	ISPdel1
	;
	ld	R16,Z+
	out	spdr,R16
	;12 cyklu pauza
	ldi	R16,3
ISPdel2:	dec	R16
	brne	ISPdel2
	cpi	R30,low(OutputFIFO+FIFOsize-2)
	ldi	R16,high(OutputFIFO+FIFOsize-2)
	cpc	R31,R16
	;
	sbi	portb,2
	nop
	ld	R16,Z+
	out	spdr,R16
	ld	R16,Z+
	;pauza 15 cyklu
	brne	NeKonec
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)
	rjmp	JoKonec
NeKonec:	nop
	nop
	nop
JoKOnec:	sts	FIFOptr,R30
	sts	FIFOptr+1,R31
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	;
	out	spdr,R16
	;pauza 15 cyklu
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	adiw	R30,0	;2 cykly
	nop
	in	R31,icr1h	;misto pop
	in	R16,icr1l	;misto pop
	out	sreg,R16	;misto pop
	in	R16,ocr1bh	;misto pop
	in	R30,ocr1bl	;misto pop
	cbi	portb,2
	
	.endif
	
	reti
	
;*******************************************************************************************	
;	cteni tlacitek - obsluha preruseni, vystup FIFO do DAC blokovan
;*******************************************************************************************
CteniTlacitek:	push	R20
	push	R19
	push	R17
	push	R16
	in	R16,sreg
	push	R16
	in	R16,ddra
	push	R16
	in	R16,porta
	push	R16
	;
	ldi	R16,0
	out	ddra,R16
	ldi	R16,255
	out	porta,R16
	nop
	nop
	nop
	nop

	rcall	RDbutony

	cpi	R20,0
	brne	NeNicStiskl
	rjmp	NicStiskl	;preskoc, kdyz nic neni stisknuto
	;obsluha pri stisku tlacitka (zmeny)
NeNicStiskl:	bst	R19,1	;dalsi song
	brtc	NeIncSongZ
	rcall	IncSongPTR
	ldi	R16,1
	sts	ButtonStack+2,R16
	rjmp	NecoStiskl
NeIncSongZ:	bst	R19,0	;predchozi song
	brtc	NeDecSongZ
	rcall	DecSongPTR
	ldi	R16,1
	sts	ButtonStack+2,R16
	rjmp	NecoStiskl
NeDecSongZ:	bst	R19,3	;posuv vpred
	brtc	NeIncListZ
	rcall	IncListPTR
	ldi	R16,1
	sts	ButtonStack+2,R16
	rjmp	NecoStiskl
NeIncListZ:	bst	R19,4	;vyber slozky
	brtc	NeChangeFoldZ
	rcall	ToggleInFoldBit
	ldi	R16,1
	sts	ButtonStack+2,R16
	rjmp	NecoStiskl
NeChangeFoldZ:	bst	R19,5	;START / STOP
	brtc	NeStartStopZ
	rcall	StartStop
	ldi	R16,1
	sts	ButtonStack+2,R16
	rjmp	NecoStiskl
NeStartStopZ:	rjmp	StavySet	;-)

	;obsluha pri drzeni tlacitka (stavy)
StavySet:	lds	R16,ButtonStack+1
	dec	R16
	sts	ButtonStack+1,R16
	breq	ButAutoDelayY
	rjmp	NicStiskl
ButAutoDelayY:	inc	R16
	sts	ButtonStack+1,R16
	;uz zjistovat
	bst	R20,1
	brtc	NeIncSongS	;dalis song
	ldi	R17,10
	rcall	AutoSpeedR
	brtc	NeIncSongS
	rcall	IncSongPTR
	rjmp	NecoStisklS
NeIncSongS:	bst	R20,0
	brtc	NeDecSongS	;predchozi song
	ldi	R17,10
	rcall	AutoSpeedR
	brtc	NeDecSongS
	rcall	DecSongPTR
	rjmp	NecoStisklS
NeDecSongS:	bst	R20,3
	brtc	NeIncListS	;posuv vpred
	ldi	R17,2
	rcall	AutoSpeedR
	brtc	NeIncListS
	rcall	IncListPTR
	rjmp	NecoStisklS
NeIncListS:	rjmp	NicStiskl

NecoStiskl:	ldi	R16,(15*XTAL)/20000000
	sts	ButtonStack+1,R16

NecoStisklS:	
NicStiskl:	;nastavit porta do norm. stavu
	cbi	ddrd,2
	;
	pop	R16
	out	porta,R16
	pop	R16
	out	ddra,R16
	pop	R16
	out	sreg,R16
	pop	R16
	pop	R17
	pop	R19
	pop	R20
	reti
;-------------------------------------------------------------------------------------------
;	tady uz jednotlive funkce tlacitek
;-------------------------------------------------------------------------------------------
	;dalsi song
IncSongPTR:	lds	R16,MenuVars
	bst	R16,7	;jina funkce tlacitka?
	brts	IncFolderPTR	;dalsi adresar
	lds	R16,SongPTR
	inc	R16
	lds	R17,SongN
	cp	R16,R17
	brne	NullSongInc
	clr	R16
NullSongInc:	sts	SongPTR,R16
	lds	R16,BitVars
	andi	R16,0b10000000
	ori	R16,0b00000001
	sts	BitVars,R16
	lds	R16,LastComVars
	andi	R16,0b11111100	;zmena skladby vpred
	sts	LastComVars,R16
	ret
	;dalsi adresar
IncFolderPTR:	lds	R16,FolderPTR
	inc	R16
	lds	R17,FolderN
	cp	R16,R17
	brne	NullFoldInc
	clr	R16
NullFoldInc:	sts	FolderPTR,R16
	lds	R16,MenuVars
	ori	R16,0b01000000
	sts	MenuVars,R16
	lds	R16,LastComVars
	andi	R16,0b01111111	;zmena adresare vpred
	sts	LastComVars,R16
	ret
	;predchozi song
DecSongPTR:	lds	R16,MenuVars
	bst	R16,7	;jina funkce tlacitka?
	brts	DecFolderPTR	;predchozi adresar
	lds	R16,SongPTR
	dec	R16
	cpi	R16,255
	brne	NullSongDec
	lds	R16,SongN
	dec	R16
NullSongDec:	sts	SongPTR,R16
	lds	R16,BitVars
	andi	R16,0b10000000
	ori	R16,0b00000001
	sts	BitVars,R16
	lds	R16,LastComVars
	andi	R16,0b11111100	;zmena skladby zpet
	ori	R16,0b00000001	;vpred
	sts	LastComVars,R16
	ret
	;predchozi adresar
DecFolderPTR:	lds	R16,FolderPTR
	dec	R16
	cpi	R16,255
	brne	NullFoldDec
	lds	R16,FolderN
	dec	R16
NullFoldDec:	sts	FolderPTR,R16
	lds	R16,MenuVars
	ori	R16,0b01000000
	sts	MenuVars,R16
	lds	R16,LastComVars
	andi	R16,0b01111111	;zmena adresare zpet
	ori	R16,0b10000000	;vpred
	sts	LastComVars,R16
	ret
	;dalsi list
IncListPTR:	push	R30
	push	R31
	ldi	R30,low(ClustCountT*2)
	ldi	R31,high(ClustCountT*2)
	lds	R16,SecPerCluster
NotIncKonstF:	lpm	R17,Z+
	cp	R16,R17
	breq	IncKonstFound
	adiw	R30,1
	rjmp	NotIncKonstF
IncKonstFound:	lpm	R16,Z+
	sts	IncDecPosKonst,R16
	lds	R16,BitVars
	ori	R16,0b00000010
	sts	BitVars,R16
	pop	R31
	pop	R30
	ret
	;start/stop
StartStop:	lds	R16,BitVars
	ldi	R17,0b10000000
	eor	R16,R17
	sts	BitVars,R16
	ret
	;vstup/vystup do vyberu adresare
ToggleInFoldBit:	lds	R16,MenuVars
	ldi	R17,0b10000000
	eor	R16,R17
	sts	MenuVars,R16
	ret
	;rychlost automatickeho pricitani pri drzeni
AutoSpeedR:	clt
	lds	R16,ButtonStack+2
	dec	R16
	sts	ButtonStack+2,R16
	brne	NeAutoSpeed
	sts	ButtonStack+2,R17
	set
NeAutoSpeed:	ret
	;prevracena hodnota
ClustCountT:	.db	1,128
	.db	2,64
	.db	4,32
	.db	8,16
	.db	16,8
	.db	32,4
	.db	64,2
	.db	128,1
;-------------------------------------------------------------------------------------------
;	nacte zmeny tlacitek do R19 a stavy do R20 
;-------------------------------------------------------------------------------------------
RDbutony:	sbi	ddrd,2
	nop
	nop
	nop
	nop
	in	R20,pina	;nacteni stavu na porta
	cbi	ddrd,2
	;vyhodnoceni zmen
	lds	R16,ButtonStack
	sts	ButtonStack,R20
	eor	R16,R20
	com	R20	;v R20 stavy (pri podrzeni tlacitka) jednotlivych tlacitek
	and	R16,R20
	mov	R19,R16	;v R19 zmeny (z nestiknuteho do stisknuteho stavu) jednotlivych tlacitek
	ret
;*******************************************************************************************
;	dalsi funkce souvisejici s menu apod.
;*******************************************************************************************	
;-------------------------------------------------------------------------------------------
;	kdyz je skladba neprehratelna, tak vybrat dalsi, ale rozhodnout, jestli 
;	vpred nebo vzad podle posledniho smeru  
;-------------------------------------------------------------------------------------------
SkipNotPCMfile:	lds	R16,LastComVars
	bst	R16,1	;nastaveno po skonceni skladby - vzdy skldba +
	brts	BadSongInc
	bst	R16,0	;posledni zmena byla +
	brtc	BadSongInc
	;predchozi skladbu
	rcall	DecSongPTR
	rjmp	BadSongSkipOk
	;dalsi skladbu
BadSongInc:	rcall	DecSongPTR
	;zmena provedena
BadSongSkipOk:	ret
;*******************************************************************************************
;	Inicializace
;*******************************************************************************************
Init:	;pocatecni nastaveni portu a pinu
	ldi	R16,0b11111111
	out	ddra,R16
	ldi	R16,0b11111011
	out	ddrd,R16
	ldi	R16,0b11111111
	out	ddrb,R16
	ldi	R16,0b11111111
	out	ddrc,R16
	sbi	portd,7	;IOWR
	sbi	portd,3	;IORD
	sbi	portb,3	;RAM WR
	sbi	portd,4	;RAM OE
	sbi	portd,6	;A16-A19 buffer CK
	sbi	portd,5	;A8-A15 buffer CK
	cbi	portb,0	;LCD E
	cbi	portb,1	;LCD RS
	cbi	portd,2	;com. tlacitka
	;stack ptr
	ldi	R16,high(ramend)
	out	sph,R16	;nastav SP na konec SRAM
	ldi	R16,low(ramend)
	out	spl,R16	;nastav SP na konec SRAM
	;timer 0 - generuje vzorkovaci kmitocet
	ldi	R16,0b00001010	;timer 0 - delitel XTAL/8
	out	tccr0,R16
	;timer 2 pro cteni tlacidel
	ldi	R16,0b01000111
	out	tccr2,R16
	ldi	R16,(255*(XTAL/10))/2000000	;timer 2: asi 75Hz
	out	ocr2,R16
	;SPI rozhrani pro vytvoreni I2S sbernice	
	ldi	R16,0b01010000
	out	spcr,R16
	ldi	R16,0b00000001
	out	spsr,R16
	;USART pro prijem/vysilani dat, 8bit, 1 stop, bez parity
	ldi	R16,0b01100010
	out	ucsra,R16
	ldi	R16,0b00011000
	out	ucsrb,R16
	ldi	R16,0b10000110
	out	ucsrc,R16
	ldi	R16,0b00000000
	out	ubrrh,R16
	;hodnoty plati pro XTAL=20MHz
;	ldi	R16,21	;115200bd
;	ldi	R16,10	;230400bd
;	ldi	R16,4	;500000bd
;	ldi	R16,2	;833333bd
;	ldi	R16,1	;1250000bd
;	ldi	R16,0	;2500000bd
	;hodnoty plati pro XTAL=16MHz
;	ldi	R16,16	;115200bd
;	ldi	R16,8	;230400bd
;	ldi	R16,3	;500000bd
;	ldi	R16,1	;1000000bd
	ldi	R16,0	;2000000bd
	;
	out	ubrrl,R16
	;
	ldi	R16,20
	rcall	DelayLongVar
	;inicializace LCD
	rcall	LCDinit
	;
	rcall	WaitDriveBSY	;cekat az je HDD/CF ready prijimat instrukce
	rcall	WaitDriveRDY	;u HDD jeste cekat na roztoceni
	;
	rcall	IdentIDEdrive	;precist identifikacni blok
	rcall	SetDriveParam	;nastavit fizickou geometrii HDD (nektere HDD to vyzaduji)
	;
	rcall	ReadFATparam	;nacist nektere parametry FAT16
	rcall	CopyFATextSRAM	;kopirovat FAT do externi SRAM
	;
	rcall	CountFolders	;spocitat adresare v root
	lds	R16,FolderN
	cpi	R16,0	;nalezeny adresare
	brne	SomeFolderFound
	;nenalezeny zadne adresare
	rcall	LCDclrAll
	ldi	R16,0b10000000
	rcall	LCDsetPos
	ldi	R30,low(TextNoFoldT*2)
	ldi	R31,high(TextNoFoldT*2)
	rcall	LCDwrStrFLASH	;"V root nejsou zadne adresare"
	rjmp	PC	;vytuhnout
	;nalezeny nejake adresare
SomeFolderFound:	ldi	R16,0b00000000
	sts	LastComVars,R16	;priznaky nekterych funkci tlacitek, ktere zustavaji nastavene i po jejich vykonani
	ldi	R16,0b10000000
	sts	MenuVars,R16	;po zapnuti automaticky do menu adresare
	ldi	R16,0b00000000
	sts	BitVars,R16	;pocatecni stav: stop
	
;*********************************************************************************************	
;	vyber adresare
;*********************************************************************************************	
SelFolder:	ldi	R16,0b10000000
	out	timsk,R16
	sei
	;nulovat posuv nazvu na LCD
	rcall	ResetRNameVars
	ldi	R16,NameRollSpeed
	sts	SongNameRSpeed,R16
	
SelFolder1:	cli
	lds	R16,MenuVars
	andi	R16,0b10111111
	sts	MenuVars,R16
	rcall	LoadFolder
	clr	R16
	sts	SongPTR,R16
	rcall	LCDwrNameFormat
	rcall	ResetRNameVars	;nulovat promenne pro vypis dlouheho jmena
	sei
	
SelFolderWait:	rcall	LCDwrNameStop	;roluj dlouhe jmeno adresare
	lds	R16,MenuVars
	bst	R16,6	;zmena adresare?
	brts	SelFolder1	;jo
	;ne, jeste v menu?
	bst	R16,7	;jeste v menu adresare?
	brts	SelFolderWait	;jo
	;uz ne, je v tom adresari neco?
	lds	R16,SongN
	cpi	R16,0
	brne	NewSong
	;prazdny adresar
	lds	R16,MenuVars
	ori	R16,0b10000000	;zpet do menu adresare
	sts	MenuVars,R16
	rjmp	SelFolderWait
	;neni prazdny
;*********************************************************************************************	
;	prehrat skladbu zvolenou SongPTR
;*********************************************************************************************
NewSong:	cli
	in	R16,timsk
	andi	R16,0b01111101
	out	timsk,R16	;zastavit timer
	;nulovat priznak noveho souboru
	lds	R16,BitVars
	andi	R16,0b11111110
	sts	BitVars,R16
	;nacist slozku
	rcall	LoadFolder
	;nacist seznam clusteru teto skladby do SRAM
	rcall	LoadSongClust
	;resety ukazatelu pro FIFO
	ldi	R30,low(OutputFIFO+0)	
	ldi	R31,high(OutputFIFO+0)
	ldi	R28,low(FIFOptr)
	ldi	R29,high(FIFOptr)
	st	Y+,R30	;RD adresa ve FIFO
	st	Y+,R31
	ldi	R30,low(OutputFIFO+0)
	ldi	R31,high(OutputFIFO+0)
	st	Y+,R30	;WR adresa ve FIFO
	st	Y+,R31
	;pozice v souboru
	clr	R16
	sts	SongPos+0,R16
	sts	SongPos+1,R16
	;nulovat posuv nazvu na LCD
	rcall	ResetRNameVars
	;SRAM adresu na 1. cluster
	rcall	ClustStrSRAMad	
	;nastaveni formatu PCM WAV
	rcall	LoadSRAMword	;cislo clusteru z SRAM
	rcall	CountSectorAd	;spocitat adresu 1. sektoru z clusteru
	rcall	RDsectorLBA	;nacist 1 sektor skladby
	;zjisteni typu WAVu
	lds	R16,OutputFIFO+0x14	;typ?
	cpi	R16,0x01
	brne	NotPCMfile	;PCM?
	;je to PCM
	lds	R16,OutputFIFO+0x16	;pocet kanalu
	lds	R17,OutputFIFO+0x18
	lds	R18,OutputFIFO+0x18+1	;vzorkovaci frekvence
	lds	R19,OutputFIFO+0x22	;pocet bitu na vzorek
	;porovnani s tabulkou podporovanych typu
	ldi	R30,low(FormatT*2)
	ldi	R31,high(FormatT*2)
	;
TestNextFormat:	lpm	R0,Z+
	lpm	R1,Z+
	lpm	R2,Z+
	lpm	R3,Z+	;parametry formatu
	lpm	R20,Z+	;konstanta pro casovac
	lpm	R21,Z+	;konstanta rychlosti rolovani textu
	;
	cp	R0,R16
	cpc	R1,R17
	cpc	R2,R18
	cpc	R3,R19
	breq	FormatFound
	lpm	R22,Z
	cpi	R22,0xFF
	brne	TestNextFormat	;dokud neni konec tabulky, hledat format
	;nepodporovany format
NotPCMfile:	rcall	SkipNotPCMfile	;preskocit skladbu, neni to PCM nebo ma spatny format
	ldi	R20,50	;aby to neco delalo
	;nalezen podporovany format
FormatFound:	out	ocr0,R20	;nastavit casovac
	sts	SongNameRSpeed,R21	;se zmenou vzorkovani by se menila rychlost rolovani, takze je taky v tabulce
	sts	SongFormat,R0	;mono/stereo
	;vypis nazev skladby
	rcall	LCDwrNameFormat
	;SRAM adresu na 1. clusteru
	rcall	ClustStrSRAMad
	;a spustit vzorkovaci casovac
	rcall	ClrFIFOgarbage
	ldi	R16,0b10000010
	out	timsk,R16
	sei
;*********************************************************************************************	
;	v teto smycce probiha vlastni prehravani
;*********************************************************************************************
	;nejdriv vypocet 1. sektoru zvoleneho clusteru
PlayNextCluster:	rcall	LoadSRAMword	;cislo clusteru z SRAM
	;
	lds	R26,SongLen+0
	lds	R27,SongLen+1
	sbiw	R26,1
	lds	R24,SongPos+0
	lds	R25,SongPos+1
	cp	R26,R24
	cpc	R27,R25
	brcc	NotEndOFSong	;test na konec skladby
	;dalsi skladba
	lds	R16,SongPTR
	inc	R16
	lds	R17,SongN
	cp	R16,R17
	brne	NullSongInc1
	clr	R16
NullSongInc1:	sts	SongPTR,R16
	rjmp	NewSong
	;neni to konec skladby, hraje se dal
NotEndOFSong:	rcall	CountSectorAd	;spocitat sektor z clusteru
	;	
	lds	R26,SecPerCluster	;pocet sektoru na cluster
	;
RdSec1:	push	R26
RdSec2:	;play/stop podle bitu 7 v BitVars
	cli
	lds	R16,BitVars
	in	R17,timsk
	bst	R16,7
	bld	R17,1
	out	timsk,R17
	brts	IfPlayDoNotging
	;je tam stop,rolovat nazev
	rcall	LCDWrNameStop
	;test na zmenu adresare
	lds	R16,MenuVars
	bst	R16,7
	brtc	NotChangeFoldS
	;zmena aktivni
	pop	R26
	rjmp	SelFolder
	;test na dalsi skladbu
NotChangeFoldS:	lds	R16,BitVars
	bst	R16,0
	brtc	IfPlayDoNotging
	;dalsi skladba
	andi	R16,0b11111110
	sts	BitVars,R16
	pop	R26
	rjmp	NewSong
	;je dost mista ve FIFO
IfPlayDoNotging:	lds	R30,FIFOptr	;read
	lds	R31,FIFOptr+1
	lds	R28,FIFOptr+2	;write
	lds	R29,FIFOptr+3
	sub	R30,R28
	sbc	R31,R29
	brcc	JeTamMisto
	ldi	R26,low(FIFOsize-1)
	ldi	R27,high(FIFOsize-1)
	add	R30,R26
	adc	R31,R27
JeTamMisto:	cpi	R30,low(512)	;kdyz je alespon 512 bytu mista, povoli se nacteni dalsich 512B
	ldi	R16,high(512)
	cpc	R31,R16
	brcc	NeDohnal
	sei
	nop
	nop
	rjmp	RdSec2	;neni misto
NeDohnal:	;je tam alespon 512B
	sei

	rcall	RDsectorLBAoF	;kopirovat 1 sektor do FIFO
	;test na konec souboru
	clr	R16
	cp	R5,R16
	breq	NotEOFreached
	;konec souboru
	rcall	IncSongPTR
	pop	R26
	rjmp	NewSong
	;obsluha LCD
NotEOFreached:	rcall	LCDwrSongName
	;test na posuv pomoci tlacitek
	lds	R16,BitVars
	bst	R16,1	;posuv bit
	brtc	NePosuv
	;posuv bude
	pop	R26
	;
	rcall	CountPosuv
	rjmp	PlayNextCluster
	;posuv nebude	
NePosuv:	ldi	R16,1
	ldi	R17,0
	rcall	LBAadressAdd16	;inkrementovat adresu sektoru (dalsi sektor clusteru)
	;test na dalsi skladbu (tlacitka)
	lds	R16,BitVars
	bst	R16,0
	brtc	NeNewSong	;test na dalsi skladbu (tlacitka)
	;novy song
	andi	R16,0b11111110
	sts	BitVars,R16
	pop	R26
	rjmp	NewSong
NeNewSong:	;test na menu "zmena adresare"
	lds	R16,MenuVars
	bst	R16,7
	brtc	NotFoldMenu1
	;je aktivni
	pop	R26
	rjmp	SelFolder
	;hrat dal
NotFoldMenu1:	pop	R26	
	dec	R26
	breq	NotRdSec1
	rjmp	RdSec1	;dalsi sektor
	;pricist k pocitadlu clusteru
NotRdSec1:	lds	R26,SongPos+0
	lds	R27,SongPos+1
	adiw	R26,1
	sts	SongPos+0,R26
	sts	SongPos+1,R27
	;
	rjmp	PlayNextCluster	;dalsi cluster
;-------------------------------------------------------------------------------------------
;	provest posuv ve skladbe (po stisku tlacitek)
;-------------------------------------------------------------------------------------------
CountPosuv:	lds	R24,IncDecPosKonst
	clr	R25
	lds	R26,SongPos+0
	lds	R27,SongPos+1
	add	R26,R24
	adc	R27,R25	;provest posuv o vypocteny pocet clusteru +
	lsl	R24
	rol	R25
	sbiw	R24,2
	add	R11,R24
	adc	R12,R25	;a ted pricist k ukazateli na cluster
	sts	SongPos+0,R26
	sts	SongPos+1,R27
	;ted jeste upravit udaj o zbyvajicich datech
	lds	R20,SongLenBytes+0
	lds	R21,SongLenBytes+1
	lds	R22,SongLenBytes+2
	lds	R23,SongLenBytes+3	;nacist
	;
	lds	R24,IncDecPosKonst	;pocet clusteru o ktere se provede posuv
	lds	R25,SecPerCluster	;sektoru na cluster
	mul	R24,R25	;pocet preskocenych sektoru
	movw	R2,R0
	clr	R4
	clr	R1
	lsl	R2
	rol	R3
	rol	R4	;u ted uz by to mel byt pocet preskocenych Bytu
	;
	sub	R20,R1
	sbc	R21,R2
	sbc	R22,R3
	sbc	R23,R4	;odecist preskocene Byty
	;
	sts	SongLenBytes+0,R20
	sts	SongLenBytes+1,R21
	sts	SongLenBytes+2,R22
	sts	SongLenBytes+3,R23	;ulozit
	;
	lds	R16,BitVars
	andi	R16,0b11111101
	sts	BitVars,R16
	ret
;-------------------------------------------------------------------------------------------
;	vymazat FIFO
;-------------------------------------------------------------------------------------------
ClrFIFOgarbage:	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)
	ldi	R28,low(FIFOsize)
	ldi	R29,high(FIFOsize)
	ldi	R16,0
UnGarbageFIFO:	st	Z+,R16
	subi	R28,1
	sbci	R29,0
	brne	UnGarbageFIFO
	ret
	
;*******************************************************************************************
;	tady by mely byt vsechny rutiny pro praci s IDE apod.
;*******************************************************************************************
;-------------------------------------------------------------------------------------------
;	nacte sektor do zasobniku
;-------------------------------------------------------------------------------------------
RDsectorLBAoF:	;zablokovat cteni tlacitek
	in	R16,timsk
	andi	R16,0b01111111
	out	timsk,R16
	;test, zde uz je dosazeni konce FIFO pameti
	rcall	SetLBAadressRD
	rcall	WaitDriveBSY
	rcall	WaitDataReady
	rcall	SetDriveDataReg
	;zbyvajici data souboru
	lds	R20,SongLenBytes+0
	lds	R21,SongLenBytes+1
	lds	R22,SongLenBytes+2
	lds	R23,SongLenBytes+3
	clr	R5
	;
	ldi	R16,0b00000000
	out	ddra,R16
	out	ddrc,R16
	;
	lds	R30,FIFOptr+2	;na WR adresu
	lds	R31,FIFOptr+3
	;nastavit bit T podle mono/stereo
	lds	R16,SongFormat
	bst	R16,1
	;
	ldi	R18,0	;256 slov
RDsectorRoF:	cbi	portd,3
	nop
	nop
	nop
	nop
	nop
	nop
	clr	R16
	clr	R17
	cp	R5,R16
	brne	OEFreached
	in	R17,pina
	in	R16,pinc
OEFreached:	sbi	portd,3
	;
	st	Z+,R17
	st	Z+,R16
	brts	StereoFRD
	;mono
	st	Z+,R17	;ukladat do obou kanalu tentyz vzorek
	st	Z+,R16
	;odecist 2B od delky souboru
	subi	R20,2
	sbci	R21,0
	sbci	R22,0
	sbci	R23,0
	brne	NotEOF1	;uz je to konec?
	;konec souboru
	ldi	R16,0xFF
	mov	R5,R16
	;
NotEOF1:	cpi	R18,129
	breq	Next256BMono
	;stereo
StereoFRD:	;odecist 2B od delky souboru
	subi	R20,2
	sbci	R21,0
	sbci	R22,0
	sbci	R23,0
	brne	NotEOF	;uz je to konec?
	;konec souboru
	ldi	R16,0xFF
	mov	R5,R16
	;
NotEOF:	cpi	R30,low(OutputFIFO+FIFOsize)
	ldi	R16,high(OutputFIFO+FIFOsize)
	cpc	R31,R16
	brne	PresMaxW
	ldi	R30,low(OutputFIFO)	;navrat na zacatek
	ldi	R31,high(OutputFIFO)
PresMaxW:	
	dec	R18
	brne	RDsectorRoF
	
MonoSecondOk:	sts	FIFOptr+2,R30
	sts	FIFOptr+3,R31
	;
	ldi	R16,0b11111111
	out	ddra,R16
	out	ddrc,R16
	
	;ulozit zbyvajici delku souboru
	sts	SongLenBytes+0,R20
	sts	SongLenBytes+1,R21
	sts	SongLenBytes+2,R22
	sts	SongLenBytes+3,R23
	;odblokovat cudly
	in	R16,timsk
	ori	R16,0b10000000
	out	timsk,R16
	ret
	;druha pulka sektoru pro mono (pri mono je dat 2x vic, takze se musi 2x cekat na dostatek mista ve FIFO)
Next256BMono:	;zaloha delky dat
	push	R20
	push	R21
	push	R22
	push	R23
	;nejdriv kontrola na konec FIFO
	cpi	R30,low(OutputFIFO+FIFOsize)
	ldi	R16,high(OutputFIFO+FIFOsize)
	cpc	R31,R16
	brne	PresMaxWM1
	ldi	R30,low(OutputFIFO)	;navrat na zacatek
	ldi	R31,high(OutputFIFO)
PresMaxWM1:	sts	FIFOptr+2,R30
	sts	FIFOptr+3,R31
	;ted na volne misto
UzDohnalM:	cli
	lds	R30,FIFOptr	;read
	lds	R31,FIFOptr+1
	lds	R28,FIFOptr+2	;write
	lds	R29,FIFOptr+3
	sub	R30,R28
	sbc	R31,R29
	brcc	JeTamMistoM
	ldi	R26,low(FIFOsize-1)
	ldi	R27,high(FIFOsize-1)
	add	R30,R26
	adc	R31,R27
JeTamMistoM:	cpi	R30,low(512)	;kdyz je alespon 512 bytu mista, povoli se nacteni dalsich 512B
	ldi	R16,high(512)
	cpc	R31,R16
	brcc	NeDohnalM
	sei
	nop
	nop
	rjmp	UzDohnalM	;neni misto
NeDohnalM:	sei
	lds	R30,FIFOptr+2	;na WR adresu
	lds	R31,FIFOptr+3
	;je tam alespon 512B, zepsat 2. pulku sektoru
	sei
	;obnova delky dat
	pop	R23
	pop	R22
	pop	R21
	pop	R20
	;
	ldi	R18,128
RDsectorRoFM:	cbi	portd,3
	nop
	nop
	nop
	nop
	nop
	nop
	clr	R16
	clr	R17
	cp	R16,R5
	brne	EOFreachedM
	in	R17,pina
	in	R16,pinc
EOFreachedM:	sbi	portd,3
	;
	st	Z+,R17
	st	Z+,R16
	st	Z+,R17	;ukladat do obou kanalu tentyz vzorek
	st	Z+,R16
	;odecist 4B od delky souboru
	subi	R20,4
	sbci	R21,0
	sbci	R22,0
	sbci	R23,0
	brne	NotEOFM	;uz je to konec?
	;konec souboru
	ldi	R16,0xFF
	mov	R5,R16
	;
NotEOFM:	cpi	R30,low(OutputFIFO+FIFOsize)
	ldi	R16,high(OutputFIFO+FIFOsize)
	cpc	R31,R16
	brne	PresMaxWM2
	ldi	R30,low(OutputFIFO)	;navrat na zacatek
	ldi	R31,high(OutputFIFO)
PresMaxWM2:	
	dec	R18
	brne	RDsectorRoFM
	rjmp	MonoSecondOk
	
;-------------------------------------------------------------------------------------------	
;	nacte sektor do zasobniku
;-------------------------------------------------------------------------------------------
RDsectorLBA:	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)
	;
	rcall	SetLBAadressRD
	rcall	WaitDataReady
	rcall	SetDriveDataReg
	rcall	RDdriveSektor
	ret
;-------------------------------------------------------------------------------------------
;	nastavi adresu v LBA modu
;-------------------------------------------------------------------------------------------
SetLBAadressCom:	rcall	WaitDriveBSY
	;D0-D7 jako vystup
	ldi	R16,0b11111111
	out	ddrc,R16
	;pocet sektoru pro pristi zapis/cteni
	ldi	R16,0b10100000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	out	portc,R6	;pocet sektoru zapisovanych najednou
	rcall	IOWRpulz
	;LBA A0-A7 (sektor)
	ldi	R16,0b10110000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	out	portc,R7	;LBA A0-A7
	rcall	IOWRpulz
	;LBA A8-A15 (cylindr low)
	ldi	R16,0b11000000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	out	portc,R8	;LBA A8-A15
	rcall	IOWRpulz
	;LBA A16-A23 (cylindr high)
	ldi	R16,0b11010000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	out	portc,R9	;LBA A16-A23
	rcall	IOWRpulz
	;LBA A24-A27 (SDH registr)
	ldi	R16,0b11100000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	ldi	R16,0b11000000	;LBA mod
	or	R16,R10	;LBA A24-A27
	out	portc,R16
	rcall	IOWRpulz
	ret
;-------------------------------------------------------------------------------------------
;	nastavi LBA adresu a vysle instrukci cteni sektoru
;-------------------------------------------------------------------------------------------
SetLBAadressRD:	ldi	R16,1	;pocet sektoru
	mov	R6,R16
	rcall	SetLBAadressCom
	rcall	WaitDriveBSY
	;cti sektor
	ldi	R16,0b11110000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	ldi	R16,0x20	;cti sektor
	out	portc,R16
	rcall	IOWRpulz
	ret
;-------------------------------------------------------------------------------------------
;	cekat dokud je HDD busy
;-------------------------------------------------------------------------------------------
WaitDriveBSY:	rcall	SetDriveStatReg
WaitDriveBSY1:	rcall	ReadDriveStat
	bst	R16,7
	brts	WaitDriveBSY1
	out	ddrc,R17
	ret
;-------------------------------------------------------------------------------------------
;	cekat na data z HDD
;-------------------------------------------------------------------------------------------
WaitDataReady:	rcall	SetDriveStatReg
WaitDataReady1:	rcall	ReadDriveStat
	bst	R16,3
	brtc	WaitDataReady1
	out	ddrc,R17
	ret
;-------------------------------------------------------------------------------------------
;	cekat dokud neni HDD ready
;-------------------------------------------------------------------------------------------
WaitDriveRDY:	rcall	SetDriveStatReg
WaitDriveRDY1:	rcall	ReadDriveStat
	bst	R16,6
	brtc	WaitDriveRDY1
	out	ddrc,R17
	ret
;-------------------------------------------------------------------------------------------
;	cist stav 
;-------------------------------------------------------------------------------------------
ReadDriveStat:	cbi	portd,3
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	in	R16,pinc
	sbi	portd,3
	nop
	nop
	nop
	nop
	ret
;-------------------------------------------------------------------------------------------
;	nastavit status registr
;-------------------------------------------------------------------------------------------
SetDriveStatReg:	in	R17,ddrc
	ldi	R16,0b00000000
	out	ddrc,R16
	ldi	R16,0b11110000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	ret
;-------------------------------------------------------------------------------------------
;	nastavit datovy registr
;-------------------------------------------------------------------------------------------
SetDriveDataReg:	ldi	R16,0b10000000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	ret
;-------------------------------------------------------------------------------------------
;	pulz na IOWR
;-------------------------------------------------------------------------------------------
IOWRpulz:	nop
	nop
	cbi	portd,7
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	sbi	portd,7
	nop
	nop
	ret
;-------------------------------------------------------------------------------------------
;	precte 1 sektor
;-------------------------------------------------------------------------------------------
RDdriveSektor:	ldi	R16,0b00000000
	out	ddra,R16
	out	ddrc,R16
	;
	ldi	R18,0	;256 slov
RDsectorR:	cbi	portd,3
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	in	R17,pina
	in	R16,pinc
	sbi	portd,3
	st	Z+,R16
	st	Z+,R17
	nop
	nop
	dec	R18
	brne	RDsectorR
	;
	ldi	R16,0b11111111
	out	ddra,R16
	out	ddrc,R16
	ret
;--------------------------------------------------------------------------------------------
;	nastavi fyzickou geometrii disku, z identifikacniho retezce
;--------------------------------------------------------------------------------------------
SetDriveParam:	ldi	R30,low(OutputFIFO+6)
	ldi	R31,high(OutputFIFO+6)
	ld	R10,Z+	;pocet hlav
	dec	R10	;(pocet hlav)-1
	adiw	R30,5
	ld	R6,Z+	;pocet sektoru na stopu
	
	rcall	SetLBAadressCom
	rcall	WaitDriveBSY
	;
	ldi	R16,0b11110000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	ldi	R16,0x91	;Set Drive Parameters
	out	portc,R16
	rcall	IOWRpulz
	rcall	WaitDriveBSY
	ret
;--------------------------------------------------------------------------------------------	
;	identifikace zarizeni na IDE
;--------------------------------------------------------------------------------------------
IdentIDEdrive:	ldi	R16,0b11111111
	out	ddrc,R16
	;cekat na roztoceni disku
	rcall	WaitDriveRDY
	;command registr
	ldi	R16,0b11110000
	out	porta,R16
	cbi	portd,5
	sbi	portd,5
	;
	ldi	R16,0xEC	;identifikace
	out	portc,R16
	rcall	IOWRpulz
	;
	rcall	WaitDataReady
	rcall	SetDriveDataReg
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)
	ldi	R16,0b00000000
	out	ddra,R16
	out	ddrc,R16
	ldi	R16,0b11111111	;zvedaci odpory
	out	porta,R16
	out	portc,R16
	;
	ldi	R19,0	;256 slov do zasobniku
ReadIdentSector:	cbi	portd,3
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	in	R17,pina	;nacist high byte
	in	R16,pinc	;nacist low byte
	sbi	portd,3
	st	Z+,R16
	st	Z+,R17
	dec	R19
	brne	ReadIdentSector
	;
	ldi	R16,0b11111111
	out	ddrc,R16
	out	ddra,R16
	ret
;-------------------------------------------------------------------------------------------
;	pricte k LBA adrese 16bit cislo R16:R17
;-------------------------------------------------------------------------------------------
LBAadressAdd16:	clr	R15
	add	R7,R16
	adc	R8,R17
	adc	R9,R15
	adc	R10,R15
	ret
;-------------------------------------------------------------------------------------------
;	pricte k LBA adrese 24bit cislo R23:R24:R25
;-------------------------------------------------------------------------------------------
LBAadressAdd24:	clr	R15
	add	R7,R23
	adc	R8,R24
	adc	R9,R25
	adc	R10,R15
	ret
;-------------------------------------------------------------------------------------------
;	pricte k LBA adrese 32bit cislo R0:R1:R2:R3
;-------------------------------------------------------------------------------------------
LBAadressAdd32:	add	R7,R0
	adc	R8,R1
	adc	R9,R2
	adc	R10,R3
	ret

;*******************************************************************************************
;	rutiny pro praci s FAT16
;*******************************************************************************************
;-------------------------------------------------------------------------------------------
;	nacte adresy 1. FAT, root adresare, zacatku dat a zapise velikost clusteru
;-------------------------------------------------------------------------------------------
ReadFATparam:	clr	R7
	clr	R8
	clr	R9
	clr	R10	;zacatek HDD (LBA 0)
	
	rcall	RDsectorLBA
	ldi	R30,low(OutputFIFO+0x1BE+0x4)
	ldi	R31,high(OutputFIFO+0x1BE+0x4)	;mezera pred boot sektorem prvni partition
	ld	R16,Z+
	
	ldi	R30,low(OutputFIFO+0x1BE+0x8)
	ldi	R31,high(OutputFIFO+0x1BE+0x8)	;mezera pred boot sektorem prvni partition
	;
	ld	R26,Z+
	ld	R27,Z+
	add	R7,R26
	adc	R8,R27	;nastavit LBA adresu boot sektoru
	;
	rcall	RDsectorLBA
	lds	R16,OutputFIFO+0xD	;velikost clusteru v sektorech
	sts	SecPerCluster,R16
	lds	R16,OutputFIFO+0x11
	lds	R17,OutputFIFO+0x11+1	;pocet vstupu do root adresare
	lsr	R17
	ror	R16
	lsr	R17
	ror	R16
	lsr	R17
	ror	R16
	lsr	R17
	ror	R16	;delit 16x na pocet sektoru
	sts	RootDirSectors,R16	;ulozit pocet sektoru root adresare
	lds	R16,OutputFIFO+0xE
	lds	R17,OutputFIFO+0xE+1	;pocet sektoru pred 1. FAT
	rcall	LBAadressAdd16
	sts	FAT1LBAadress,R7
	sts	FAT1LBAadress+1,R8
	sts	FAT1LBAadress+2,R9
	sts	FAT1LBAadress+3,R10	;LBA adresa root adresare
	lds	R16,OutputFIFO+0x16
	lds	R17,OutputFIFO+0x16+1	;pocet sektoru v 1 FAT 
	lsl	R16
	rol	R17	;2x - jsou 2 FAT 
	rcall	LBAadressAdd16
	sts	RootLBAadress,R7
	sts	RootLBAadress+1,R8
	sts	RootLBAadress+2,R9
	sts	RootLBAadress+3,R10	;LBA adresa root adresare
	;
	lds	R16,OutputFIFO+0x11
	lds	R17,OutputFIFO+0x11+1	;velikost root adresare
	lsr	R17
	ror	R16
	lsr	R17
	ror	R16
	lsr	R17
	ror	R16
	lsr	R17
	ror	R16	;/16
	rcall	LBAadressAdd16
	sts	DataLBAadress,R7
	sts	DataLBAadress+1,R8
	sts	DataLBAadress+2,R9
	sts	DataLBAadress+3,R10	;LBA adresa root adresare
	ret
;-------------------------------------------------------------------------------------------	
;	nacist FAT do externi SRAM od adresy 0 (128kB)
;-------------------------------------------------------------------------------------------
CopyFATextSRAM:	clr	R3
	clr	R4
	clr	R5
	rcall	LoadFAT1LBAad
	ldi	R24,0	;256 sektoru
	
CopyFAT:	rcall	RDsectorLBA
	rcall	SectorToSRAMext
	ldi	R16,1
	clr	R17
	rcall	LBAadressAdd16	;dalsi sektor
	dec	R24
	brne	CopyFAT
	ret
;-------------------------------------------------------------------------------------------	
;	spocitat adresare v root 
;-------------------------------------------------------------------------------------------
CountFolders:	ldi	R16,0
	sts	FolderN,R16	;nulovat pocet adresaru
	sts	FolderPTR,R16	;nulovat ukazatel na adresar
	rcall	LoadRootLBAad	;adresa root
	lds	R26,RootDirSectors	;vyhledavat v celem root adresari (pocet sektoru pro root)
	
NextRootSector:	rcall	RDsectorLBA	;nacist do zasobniku 1 sektor
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)	;zacatek zasobniku
	ldi	R25,16	;16 vstupu na sektor (512B na sektor /32B na vstup)
	;
NextRootEntry:	ld	R16,Z
	adiw	R30,0xB	;atribut vstupu
	cpi	R16,0xE5	;kontorla na smazany vstup
	breq	NotFolderEntry	;vstup smazane polozky
	;nejde o smazanou polozku
	ld	R16,Z	;atribut vstupu
	bst	R16,4	;vstup podadresare
	brtc	NotFolderEntry
	;je to adresar
	lds	R16,FolderN
	inc	R16
	sts	FolderN,R16
	;neni to adresar
NotFolderEntry:	adiw	R30,0x15	;zacatek dalsiho vstupu (+32B proti zacatku minuleho)
	;
	dec	R25
	brne	NextRootEntry	;dalsi vstup
	;
	ldi	R16,1
	ldi	R17,0
	rcall	LBAadressAdd16	;inkrementace adresy sektoru
	;
	dec	R26
	brne	NextRootSector	;dalsi sektor root adresare
	;adresare v root secteny
	ret
;-------------------------------------------------------------------------------------------
;	vybrat FolderPTR adresar z root 
;-------------------------------------------------------------------------------------------
LoadFolder:	lds	R24,FolderPTR	;cislo adresare
	inc	R24
	ldi	R28,low(OutputFIFO+512)	;od teto adresy do adresy +768 se zapisuje poslednich 8 vstupu
	ldi	R29,high(OutputFIFO+512)	;po nalezeni vstupu souboru se z tohoto zasobniku nacte dlouhy nazev
	rcall	LoadRootLBAad
	
	lds	R26,RootDirSectors	;hledat v celem root
NextRootSecFo:	rcall	RDsectorLBA	;nacist do zasobniku 1 sektor
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)	;zacatek zasobniku
	ldi	R25,16	;16 vstupu na sektor (512B na sektor /32B na vstup)
	;
NextRootEntryFo:	ld	R16,Z
	adiw	R30,0xB	;atribut vstupu
	cpi	R16,0xE5	;kontorla na smazany vstup
	breq	NotFoldEntryFo	;vstup smazane polozky
	;nejde o smazanou polozku
	ld	R16,Z	;atribut vstupu
	bst	R16,4	;vstup podadresare
	brtc	NotFoldEntryFo
	;je to adresar
	dec	R24	;snizit pocitadlo
	adiw	R30,0xF
	ld	R16,Z+
	ld	R17,Z+	;nacist cislo 1. clusteru
	sbiw	R30,0x11
	;neni to adresar
NotFoldEntryFo:	sbiw	R30,0xB
	ldi	R18,32
SaveEntryFo:	ld	R19,Z+
	st	Y+,R19
	dec	R18
	brne	SaveEntryFo
	rcall	CheckEStackEnd	;test na konec zasobniku vstupu
	;
	cpi	R24,0
	breq	FolderFound	;hledany soubor nalezen
	;
	dec	R25
	brne	NextRootEntryFo	;dalsi vstup
	;
	ldi	R16,1
	ldi	R17,0
	rcall	LBAadressAdd16	;inkrementace adresy sektoru
	;
	dec	R26
	brne	NextRootSecFo	;dalsi sektor root adresare
	;nalezen hledany adresar
FolderFound:	rcall	LoadRAMClusters	;nacist retezec clusteru tohoto adresare do ext. SRAM
	;nacist pocet skladeb v tomto adresari
	rcall	CountSongs
	ret
;-------------------------------------------------------------------------------------------
;	spocitat soubory s priponou "WAV" v aktualnim adresari
;-------------------------------------------------------------------------------------------
CountSongs:	ldi	R16,0
	sts	SongN,R16	;nulovat pocet skladeb
	rcall	ClustStrSRAMad
	;	
	lds	R26,SongLen	;vyhledavat v celem adresari (pocet clusteru adresare)
NextFoldCluster:	rcall	LoadSRAMword	;cislo clusteru ze SRAM
	rcall	CountSectorAd	;spocitat adresu 1. sektoru z clusteru	
	;
	lds	R25,SecPerCluster	;pocet sektoru na cluster
NextFoldSector:	rcall	RDsectorLBA	;nacist do zasobniku 1 sektor
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)	;zacatek zasobniku
	;
	ldi	R24,16	;16 vstupu na sektor (512B na sektor /32B na vstup)
NextFoldEntry:	ld	R16,Z
	cpi	R16,0xE5	;kontorla na smazany soubor
	brne	NotErasedFile
	;vstup smazaneho souboru
	adiw	R30,0xB
	rjmp	NotWavExtension
	;nejde o smazany soubor
NotErasedFile:	adiw	R30,0x8	;1.pismeno pripony
	ld	R16,Z+
	ld	R17,Z+
	ld	R18,Z+	;nactena pripona
	ldi	R19,'W'
	ldi	R20,'A'
	ldi	R21,'V'	;hledany retezec
	cp	R16,R19
	cpc	R17,R20
	cpc	R18,R21
	brne	NotWavExtension
	;je tam retezec "WAV"
	ld	R16,Z+	;atribut vstupu
	andi	R16,0b00011000
	cpi	R16,0
	brne	NotFileEntry
	;je to soubor, pricist 1 k poctu souboru
	lds	R16,SongN
	inc	R16
	sts	SongN,R16
	;neni to soubor
NotFileEntry:	sbiw	R30,1
	;nema priponu "WAV"
NotWavExtension:	adiw	R30,0x15	;zacatek dalsiho vstupu (+32B proti zacatku minuleho)
	;
	dec	R24
	brne	NextFoldEntry	;dalsi vstup
	;
	ldi	R16,1
	ldi	R17,0
	rcall	LBAadressAdd16	;dalsi sektor
	;
	dec	R25
	brne	NextFoldSector	;dalsi sektor root adresare
	;
	dec	R26
	brne	NextFoldCluster
	;soubory "*.WAV" secteny
	ret
;-------------------------------------------------------------------------------------------	
;	Vyhledat skladbu v adresari a nacist retezec clusteru do adresare
;-------------------------------------------------------------------------------------------
LoadSongClust:	;nejdriv najit vstup zvolene skladby
	lds	R23,SongPTR
	inc	R23	;cislo skladby+1
	ldi	R28,low(OutputFIFO+512)	;od teto adresy do adresy +768 se zapisuje poslednich 8 vstupu
	ldi	R29,high(OutputFIFO+512)	;po nalezeni vstupu souboru se z tohoto zasobniku nacte dlouhy nazev
	rcall	ClustStrSRAMad	;prvni cluster z retezu
	;	
	lds	R26,SongLen	;vyhledavat v celem adresari (pocet clusteru adresare)
NextFoldClustFI:	rcall	LoadSRAMword	;cislo clusteru ze SRAM
	rcall	CountSectorAd	;spocitat adresu 1. sektoru z clusteru	
	;
	lds	R25,SecPerCluster	;pocet sektoru na cluster
NextFoldSecFI:	rcall	RDsectorLBA	;nacist do zasobniku 1 sektor
	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)	;zacatek zasobniku
	;
	ldi	R24,16	;16 vstupu na sektor (512B na sektor /32B na vstup)
NextFoldEntryFi:	ld	R16,Z
	cpi	R16,0xE5	;kontorla na smazany soubor
	brne	NotErasedFileFi
	;vstup smazaneho souboru
	adiw	R30,0xB
	rjmp	NotWavExtFi
	;nejde o smazany soubor
NotErasedFileFi:	adiw	R30,0x8	;1.pismeno pripony
	ld	R16,Z+
	ld	R17,Z+
	ld	R18,Z+	;nactena pripona
	ldi	R19,'W'
	ldi	R20,'A'
	ldi	R21,'V'	;hledany retezec
	cp	R16,R19
	cpc	R17,R20
	cpc	R18,R21
	brne	NotWavExtFi
	;je tam retezec "WAV"
	ld	R16,Z+	;atribut vstupu
	andi	R16,0b00011000
	cpi	R16,0
	brne	NotFileEntryFi
	;je to soubor, pricist 1 k poctu souboru
	dec	R23
	adiw	R30,0xE
	ld	R16,Z+
	ld	R17,Z+	;pocatecni cluster souboru
	ld	R0,Z+
	ld	R1,Z+
	ld	R2,Z+
	ld	R3,Z+	;delka souboru v Bytech
	sbiw	R30,0x14
	;neni to soubor
NotFileEntryFi:	sbiw	R30,1
	;nema priponu "WAV"
NotWavExtFi:	sbiw	R30,0xB	;zpet na zacatek tohoto vstupu
	;ted se ulozi cely tento vstup do zasobniku
	ldi	R18,32
SaveEntryFi:	ld	R19,Z+
	st	Y+,R19
	dec	R18
	brne	SaveEntryFi
	rcall	CheckEStackEnd	;test na konec zasobniku vstupu
	;
	cpi	R23,0
	breq	FileFound	;hledany soubor nalezen
	;
	dec	R24
	brne	NextFoldEntryFi	;dalsi vstup
	;
	ldi	R16,1
	ldi	R17,0
	rcall	LBAadressAdd16	;dalsi sektor
	;
	dec	R25
	brne	NextFoldSecFi	;dalsi sektor root adresare
	;
	dec	R26
	brne	NextFoldClustFi
	;soubor nalezen
FileFound:	sts	SongLenBytes+0,R0
	sts	SongLenBytes+1,R1
	sts	SongLenBytes+2,R2
	sts	SongLenBytes+3,R3
	;kopirovat retezec clusteru od clusteru R16:R17 do SRAM
	rcall	LoadRAMClusters
	ret
;-------------------------------------------------------------------------------------------
;	test na naplneni zasobniku poslednich vstupu, pak reset ukazatele na zacatek
;-------------------------------------------------------------------------------------------
CheckEStackEnd:	ldi	R18,low(OutputFIFO+768)
	ldi	R19,high(OutputFIFO+768)	;konec zasobniku
	cp	R28,R18
	cpc	R29,R19
	brne	EndESReached
	ldi	R28,low(OutputFIFO+512)
	ldi	R29,high(OutputFIFO+512)	;reset ukazatele zasobniku
EndESReached:	ret
;-------------------------------------------------------------------------------------------
;	nacist dlouhe jmeno do zasobniku nazev
;-------------------------------------------------------------------------------------------
ReadLongName:	ldi	R20,low(OutputFIFO+512)
	ldi	R21,high(OutputFIFO+512)	;zacatek zasobniku
	rcall	DecEntryNumber	;navrat na zacatek kratkeho vstupu
	;nekdy nedojde k zapisu dlouheho nazvu, nejspis je to jen v pripade, ze nazev 
	;lze beze zmen ulozit do kratkeho vstupu (prinejmensim u adresaru se mi to tak chova)
	;takze se do zasobniku nejdiv nacte kratky nazev
	rcall	LoadShortName
	;1. cast dlouheho nazvu
	rcall	DecEntryNumber	;a ted na zacatek 1. casti dlouheho nazvu
	;ted test, jestli tam vubec je
	ld	R16,Y
	cpi	R16,0x01
	breq	LFNok	;je tam dlouhe nazev
	cpi	R16,0x41
	breq	LFNok	;je tam dlouhe nazev
	;dlouhy nazev neni
	rjmp	NotLFNfound
	;dlouhy nazev je
LFNok:	ldi	R30,low(SongNameString)
	ldi	R31,high(SongNameString)	;ukazatel na zasobnik nazvu
	clt		;priznak konce nazvu
	clr	R18	;nulovat pocet znaku nazvu
	
NextPartOfEntry:	ld	R19,Y+	;poradove cislo teto casti nazvu
	ldi	R17,5	;5 pismen
	rcall	CopyFewChars
	adiw	R28,3
	ldi	R17,6	;6 pismen
	rcall	CopyFewChars
	adiw	R28,2
	ldi	R17,2	;2 pismena
	rcall	CopyFewChars
	rcall	DecEntryNumber
	rcall	DecEntryNumber	;na predchozi cast nazvu
	cpi	R19,0x40	;kdyz je k poradovemu cislu pricteno 40h
	brcs	NextPartOfEntry
	;tak je nazev nacten kompletne
NotLFNfound:	sts	SongNameLen,R18
	;vyplnit zbytek nazvu mezerami
	ldi	R18,low(SongNameString+92)
	ldi	R19,high(SongNameString+92)	;ukazatel na zasobnik nazvu
	ldi	R16,' '
FillSpaces:	st	Z+,R16
	cp	R30,R18
	cpc	R31,R19
	brne	FillSpaces
	ret
	;nacteni krakeho jmena
LoadShortName:	ldi	R30,low(SongNameString)
	ldi	R31,high(SongNameString)	;ukazatel na zasobnik nazvu
	ldi	R17,11	;fixne 11 znaku nazvu
CopyShortEName:	ld	R16,Y+
	st	Z+,R16
	dec	R17
	brne	CopyShortEName	;dalsi znak
	sbiw	R28,11	;navrat na zacatek vstupu
	ldi	R18,11	;nazev je dlouhy 11 znaku
	ret
;-------------------------------------------------------------------------------------------
;	kopiruje R17 pismen nazvu
;-------------------------------------------------------------------------------------------		
CopyFewChars:	ld	R16,Y+
	brts	NotCopyFewChars
	cpi	R16,0x00
	breq	CopyFewChars3
	cpi	R16,0xFF
	brne	CopyFewChars1
CopyFewChars3:	adiw	R28,1
	set
	rjmp	CopyFewChars2
CopyFewChars1:	st	Z+,R16
	inc	R18	;pocet znaku nazvu
CopyFewChars2:	adiw	R28,1
	dec	R17
	brne	CopyFewChars
NotCopyFewChars:	ret
;-------------------------------------------------------------------------------------------
;	navrat o vstup zpet
;-------------------------------------------------------------------------------------------	
DecEntryNumber:	cp	R28,R20
	cpc	R29,R21
	brne	EntStackStart
	;kdyz je na zacatku, tak nahrat konec - 32
	ldi	R28,low(OutputFIFO+768)
	ldi	R29,high(OutputFIFO+768)	;konec zasobniku
EntStackStart:	sbiw	R28,32	;o vstup zpet
	ret
;-------------------------------------------------------------------------------------------	
;	vypocet adresy 1. sektoru z clusteru R16:R17
;-------------------------------------------------------------------------------------------
CountSectorAd:	rcall	LoadDataLBAad	;zacatek DAT
	movw	R24,R16
	sbiw	R24,2	;odecist 2, protoze mrkvo$oft ....
	;vypocet pocatecniho sektoru z clusteru R24:R25
	lds	R18,SecPerCluster	
	mul	R25,R18
	movw	R4,R0
	mul	R24,R18
	clr	R2
	clr	R3
	clr	R6
	add	R1,R4
	adc	R2,R5
	adc	R3,R6
	rcall	LBAadressAdd32	;a ted to pricist k adrese 1. sektoru dat
	ret
;--------------------------------------------------------------------------------------------
;	pocatecni cluster je R16:R17, ted nacist poradi clusteru do externi SRAM
;	nakonec se nacte dlouhe jmeno (LFN) do zasobniku jmena
;--------------------------------------------------------------------------------------------
LoadRAMClusters:	clr	R3
	clr	R4
	clr	R5
	inc	R5
	inc	R5	;bunka FAT pro (prvni cluster)-2 (+131072B SRAM)
	rcall	Word2SRAM	;ulozit pocatecni cluster do SRAM
	
	clr	R26
	clr	R27
NExtCluster2RAM:	clr	R18
	lsl	R16
	rol	R17
	rol	R18
	mov	R11,R16
	mov	R12,R17
	mov	R13,R18
	rcall	LoadSRAMword	;nacist cilslo dalsiho clusteru
	rcall	Word2SRAM	;a zase ulozit do SRAM
	
	adiw	R26,1

	ldi	R18,0xF8	;Kdyz je to posledni cluster -
	ldi	R19,0xFF
	cp	R16,R18
	cpc	R17,R19
	brcs	NExtCluster2RAM
	;- tak je nacitani ukonceno
	sts	SongLen+0,R26
	sts	SongLen+1,R27	;delka souboru/adresare v clusterech
	;vytvorit nazev ze vstupu v zasobniku
	rcall	ReadLongName
	;
	ret
;-------------------------------------------------------------------------------------------
;	nahrat LBA adresu 1.FAT
;-------------------------------------------------------------------------------------------
LoadFAT1LBAad:	lds	R7,FAT1LBAadress+0
	lds	R8,FAT1LBAadress+1
	lds	R9,FAT1LBAadress+2
	lds	R10,FAT1LBAadress+3
	ret
;-------------------------------------------------------------------------------------------
;	nahrat LBA adresu root adresare
;-------------------------------------------------------------------------------------------
LoadRootLBAad:	lds	R7,RootLBAadress+0
	lds	R8,RootLBAadress+1
	lds	R9,RootLBAadress+2
	lds	R10,RootLBAadress+3
	ret
;-------------------------------------------------------------------------------------------
;	nahrat LBA adresu prvniho sektoru dat
;-------------------------------------------------------------------------------------------
LoadDataLBAad:	lds	R7,DataLBAadress+0
	lds	R8,DataLBAadress+1
	lds	R9,DataLBAadress+2
	lds	R10,DataLBAadress+3
	ret

;*******************************************************************************************
;	Rutiny pro praci s externi SRAM
;*******************************************************************************************
;-------------------------------------------------------------------------------------------
;	SRAM adresu na 1. cluster
;-------------------------------------------------------------------------------------------
ClustStrSRAMad:	clr	R11
	clr	R12
	clr	R13
	inc	R13
	inc	R13	;prvni cluster od adresy 131072 SRAM
	ret
;-------------------------------------------------------------------------------------------
;	kopiruje 512B zasobniku interni RAM do exteri na adresu od R3:R4:R5
;-------------------------------------------------------------------------------------------
SectorToSRAMext:	ldi	R30,low(OutputFIFO)
	ldi	R31,high(OutputFIFO)
	clr	R14
	inc	R14
	clr	R15
	ldi	R17,0
	ldi	R18,2	;512B
SecToSRAMext1:	ld	R16,Z+
	out	portc,R16	;data na port
	out	porta,R5
	cbi	portd,5
	sbi	portd,5	
	out	porta,R4
	cbi	portd,6
	sbi	portd,6
	out	porta,R3
	add	R3,R14
	adc	R4,R15
	adc	R5,R15
	cbi	portb,3
	nop
	sbi	portb,3
	;
	dec	R17
	brne	SecToSRAMext1
	dec	R18
	brne	SecToSRAMext1
	ret
;-------------------------------------------------------------------------------------------
;	zapise word R16:R17 na adresu R3:R4:R5 SRAM
;-------------------------------------------------------------------------------------------
Word2SRAM:	clr	R14
	inc	R14
	clr	R15
	;
	out	portc,R16	;data na port
	out	porta,R5
	cbi	portd,5
	sbi	portd,5	
	out	porta,R4
	cbi	portd,6
	sbi	portd,6
	out	porta,R3
	add	R3,R14
	adc	R4,R15
	adc	R5,R15
	cbi	portb,3
	nop
	sbi	portb,3
	;
	out	portc,R17	;data na port
	out	porta,R5
	cbi	portd,5
	sbi	portd,5	
	out	porta,R4
	cbi	portd,6
	sbi	portd,6
	out	porta,R3
	add	R3,R14
	adc	R4,R15
	adc	R5,R15
	cbi	portb,3
	nop
	sbi	portb,3
	;
	ret
;-------------------------------------------------------------------------------------------	
;	nacte word ze SRAM z adresy R11:R12:R13 do R16:R17, inkrementuje adresu 
;-------------------------------------------------------------------------------------------
LoadSRAMword:	clr	R14
	inc	R14
	clr	R15
	out	ddrc,R15
	cbi	portd,4
	;
	out	porta,R13
	cbi	portd,5
	sbi	portd,5
	out	porta,R12
	cbi	portd,6
	sbi	portd,6
	out	porta,R11
	add	R11,R14
	adc	R12,R15
	adc	R13,R15
	in	R16,pinc
	;
	out	porta,R13
	cbi	portd,5
	sbi	portd,5
	out	porta,R12
	cbi	portd,6
	sbi	portd,6
	out	porta,R11
	add	R11,R14
	adc	R12,R15
	adc	R13,R15
	in	R17,pinc
	;	
	sbi	portd,4
	dec	R15
	out	ddrc,R15
	ret
;*******************************************************************************************
;	Tady jsou vsechny rutiny pro LCD
;*******************************************************************************************
;--------------------------------------------------------------------------------------------
;	vymaze cele LCD
;--------------------------------------------------------------------------------------------
LCDclrAll:	sbi	portb,1
	ldi	R25,128
LCDclrAll1:	ldi	R16,' '
	rcall	ByteToLCD
	dec	R25
	brne	LCDclrAll1
	ret
;--------------------------------------------------------------------------------------------
;	nastavi pozici na LCD podle R16
;--------------------------------------------------------------------------------------------
LCDsetPos:	cbi	portb,1
	rcall	ByteToLCD
	ret
;--------------------------------------------------------------------------------------------
;	posle znak z R16 na LCD
;--------------------------------------------------------------------------------------------
LCDwrChar:	sbi	portb,1
	rcall	ByteToLCD
	ret
;--------------------------------------------------------------------------------------------
;vypise retezec z od adresy udane Z, retezec se ukoncuje 0xFF, radek zalamuje 0x0
;--------------------------------------------------------------------------------------------
LCDwrStrFlash:	sbi	portb,1
LCDwrStrFlash1:	lpm	R16,Z+
	rcall	ByteToLCD
	lpm	R16,Z
	cpi	R16,0
	brne	LCDNeBrLine
	ldi	R16,0b11000000
	rcall	LCDsetPos
	sbi	portb,1
	adiw	R30,1
LCDNeBrLine:	lpm	R16,Z
	cpi	R16,255
	brne	LCDwrStrFlash1
	ret
;--------------------------------------------------------------------------------------------
;	odesle R25 znaku z RAM od ukazatele Z
;--------------------------------------------------------------------------------------------
LCDwrStrRAM:	sbi	portb,1	;data
LCDwrStrRAM1:	ld	R16,Z+
	rcall	ByteToLCD
	dec	R25
	brne	LCDwrStrRAM1
	ret
;-------------------------------------------------------------------------------------------- 	
;	inicializace LCD jako 2 radkovy
;--------------------------------------------------------------------------------------------
LCDinit:	ldi	R16,0b11111111
	out	ddrc,R16
	rcall	ByteToLCDst
	ldi	R16,0b00111000
	rcall	ByteToLCD
	ldi	R16,0b00001100
	rcall	ByteToLCD
	ldi	R16,0b10000000
	rcall	ByteToLCD
	ldi	R16,0b00000000
	out	ddrc,R16
	ret
;--------------------------------------------------------------------------------------------
;	posle byte LCD a generuje zpozdeni neco pres 40us	
;--------------------------------------------------------------------------------------------
ByteToLCD:	out	portc,R16
	sbi	portb,0
	nop
	cbi	portb,0
	ldi	R16,(220*(XTAL/10))/2000000
ByteToLCDL1:	dec	R16
	nop
	brne	ByteToLCDL1
	ret
;--------------------------------------------------------------------------------------------
;	jen zpozdeni po zapnuti (nektere LCD se nechtely inicializovat)
;--------------------------------------------------------------------------------------------
ByteToLCDst:	ldi	R17,5
	ldi	R16,0	
ByteToLCDst1:	dec	R16
	brne	ByteToLCDst1
	dec	R17
	brne	ByteToLCDst1
	ret
;--------------------------------------------------------------------------------------------
;	vypise BCD cislo bez nul na zacatku
;--------------------------------------------------------------------------------------------
LCDwrBCD:	sbi	portb,1
	clt
	mov	R16,R15
	andi	R16,0b00001111
	subi	R16,-48
	cpi	R16,48
	breq	NextNMBR1
	set
	rcall	ByteToLCD
NextNMBR1:	mov	R16,R14
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	brts	NMBR2
	cpi	R16,48
	breq	NextNMBR2
	set
NMBR2:	rcall	ByteToLCD
NextNMBR2:	mov	R16,R14
	andi	R16,0b00001111
	subi	R16,-48
	brts	NMBR3
	cpi	R16,48
	breq	NextNMBR3
	set
NMBR3:	rcall	ByteToLCD
NextNMBR3:	mov	R16,R13
	andi	R16,0b11110000
	swap	R16
	subi	R16,-48
	brts	NMBR4
	cpi	R16,48
	breq	NextNMBR4
	set
NMBR4:	rcall	ByteToLCD
NextNMBR4:	mov	R16,R13
	andi	R16,0b00001111
	subi	R16,-48
	rcall	ByteToLCD
	ret
;--------------------------------------------------------------------------------------------
;	vypise nazev skladby a jei format
;--------------------------------------------------------------------------------------------
LCDwrNameFormat:	;smazat LCD
	rcall	LCDclrAll
	ldi	R16,0b10000000
	rcall	LCDsetPos
	;vypsat cast nazvu
	ldi	R30,low(SongNameString)
	ldi	R31,high(SongNameString)
	;vypsat nazev
	ldi	R16,0b10000000
	rcall	LCDsetPos
	ldi	R25,20
	rcall	LCDwrStrRAM
	;2. radek
	ldi	R16,0b11000000
	rcall	LCDsetPos
	;soubor/adresar ?
	lds	R16,MenuVars
	bst	R16,7
	brts	ChangeFolderInf	;adresar
	;soubor - vypsat format
	mov	R16,R1
	mov	R17,R2
	rcall	bin2BCD16
	rcall	LCDwrBCD	;vypis vzorkovaci frekvenci frekvenci
	ldi	R30,low(TextHzT*2)
	ldi	R31,high(TextHzT*2)
	rcall	LCDwrStrFLASH	;"Hz"
	ldi	R16,' '
	rcall	LCDwrChar
	mov	R16,R3
	clr	R17
	rcall	bin2BCD16
	rcall	LCDwrBCD	;vypis pocet bitu
	ldi	R30,low(TextBitT*2)
	ldi	R31,high(TextBitT*2)
	rcall	LCDwrStrFLASH	;"bit"
	ldi	R16,' '
	rcall	LCDwrChar
	mov	R16,R0
	cpi	R16,0x01
	brne	JeToStereo
	ldi	R30,low(TextMonoT*2)
	ldi	R31,high(TextMonoT*2)	;"mono  "
	rjmp	JeToMono
JeToStereo:	ldi	R30,low(TextStereoT*2)
	ldi	R31,high(TextStereoT*2)	;"stereo"
JeToMono:	rcall	LCDwrStrFLASH
	rjmp	FormatInfOk
	;adresar - vypsat pocet nalezenych skladeb
ChangeFolderInf:	ldi	R30,low(TextSkladebT*2)
	ldi	R31,high(TextSkladebT*2)
	rcall	LCDwrStrFLASH	;"Skladeb: "
	lds	R16,SongN
	clr	R17
	rcall	bin2BCD16
	rcall	LCDwrBCD	;vypis pocet skladeb
	;finito	
FormatInfOk:	ret
;-------------------------------------------------------------------------------------------
;	vypisovani nazvu skladby, dlouhy nazev se posouva
;-------------------------------------------------------------------------------------------
LCDwrSongName:	;
	cli
	in	R16,timsk
	andi	R16,0b01111111
	out	timsk,R16
	sei
	;
	lds	R16,MenuVars
	bst	R16,7
	brts	InFolderMenuN
	lds	R16,BitVars
	bst	R16,7	;play/stop
InFolderMenuN:	lds	R16,SongNameDivider
	inc	R16
	sts	SongNameDivider,R16
	lds	R17,SongNameRSpeed
	brts	PlayLoadNormK
	;pri stop maximalni moznou hodnotu
	ldi	R17,255
PlayLoadNormK:	cp	R16,R17
	breq	LCDwrNameS
	rjmp	NotCanRoll
	;obsluha povolena
LCDwrNameS:	clr	R16
	sts	SongNameDivider,R16
	
	ldi	R30,low(SongNameString)
	ldi	R31,high(SongNameString)
	lds	R16,SongNamePos
	clr	R17
	add	R30,R16
	adc	R31,R17	;nastavit ofset nazvu skladby
	;vypsat nazev
	ldi	R16,0b10000000
	rcall	LCDsetPos
	ldi	R25,20
	rcall	LCDwrStrRAM
	;
	lds	R16,SongNameLen
	cpi	R16,21
	brcs	NotCanRoll
	;bazev je delsi nez 20 znaku - nazev se musi po LCD posouvat
	lds	R17,SongNamePos
	subi	R16,19
	lds	R18,SongNameRolMode
	bst	R18,0
	brts	NotRollRight
	;pro rolovani vpravo
	inc	R17
	cp	R17,R16
	brne	NotRollLeft
	dec	R17
	ldi	R19,0b00000001
	eor	R18,R19	;zmenit smer posuvu
	rjmp	NotRollLeft
NotRollRight:	;pro rolovani vlevo
	dec	R17
	cpi	R17,255
	brne	NotRollLeft
	ldi	R19,0b00000001
	eor	R18,R19	;zmenit smer posuvu
	clr	R17
NotRollLeft:	;
	sts	SongNamePos,R17	;ulozit novou pozici
	sts	SongNameRolMode,R18
NotCanRoll:	;
	cli
	in	R16,timsk
	ori	R16,0b10000000
	out	timsk,R16
	sei
	;
	ret
;-------------------------------------------------------------------------------------------
;	je tam stop,rolovat nazev
;-------------------------------------------------------------------------------------------
LCDWrNameStop:	lds	R17,SongNameDivStop
	inc	R17
	sts	SongNameDivStop,R17
	cpi	R17,(100*XTAL)/20000000
	brne	NotRolNameStop	;delitel rychlosti 1
	clr	R17
	sts	SongNameDivStop,R17
	lds	R17,SongNameDivStop+1
	inc	R17
	sts	SongNameDivStop+1,R17
	lds	R16,MenuVars
	bst	R16,7
	ldi	R16,7	;konstanta pro stop
	brtc	NotFolderMenuD
	ldi	R16,64	;a tahle je pro vyber adresare
NotFolderMenuD:	cp	R17,R16
	brne	NotRolNameStop	;delitel rychlosti 2
	clr	R17
	sts	SongNameDivStop+1,R17
	rcall	LCDwrSongName
NotRolNameStop:	ret
;-------------------------------------------------------------------------------------------
;	reset nekterych promennych, ktere souvisi s vypisem nazvu
;-------------------------------------------------------------------------------------------
ResetRNameVars:	clr	R16
	sts	SongNameDivStop+0,R16	;delitel 1 pro stop
	sts	SongNameDivStop+1,R16	;delitel 2 pro stop
	sts	SongNameDivider,R16	;delitel pro play
	sts	SongNamePos,R16	;aktualni ofset nazvu
	sts	SongNameRolMode,R16	;smer rolovani nazvu
	ret
;*******************************************************************************************
;	tady zacina matematika
;*******************************************************************************************
;***************************************************************************
;*
;* "bin2BCD16" - 16-bit Binary to BCD conversion
;*
;* This subroutine converts a 16-bit number (fbinH:fbinL) to a 5-digit 
;* packed BCD number represented by 3 bytes (tBCD2:tBCD1:tBCD0).
;* MSD of the 5-digit number is placed in the lowermost nibble of tBCD2.
;*  
;* Number of words	:25
;* Number of cycles	:751/768 (Min/Max)
;* Low registers used	:3 (tBCD0,tBCD1,tBCD2) 
;* High registers used  :4(fbinL,fbinH,cnt16a,tmp16a)	
;* Pointers used	:Z
;*
;***************************************************************************

;***** Subroutine Register Variables

	.equ	AtBCD0=13	;address of tBCD0
	.equ	AtBCD2=15	;address of tBCD1

	.def	tBCD0=r13	;BCD value digits 1 and 0
	.def	tBCD1=r14	;BCD value digits 3 and 2
	.def	tBCD2=r15	;BCD value digit 4
	.def	fbinL=r16	;binary value Low byte
	.def	fbinH=r17	;binary value High byte
	.def	cnt16a=r18	;loop counter
	.def	tmp16a=r19	;temporary value

bin2BCD16:	ldi	cnt16a,16	;Init loop counter	
	clr	tBCD2	;clear result (3 bytes)
	clr	tBCD1
	clr	tBCD0
	clr	ZH	;clear ZH (not needed for AT90Sxx0x)
bBCDx_1:	lsl	fbinL	;shift input value
	rol	fbinH	;through all bytes
	rol	tBCD0	;
	rol	tBCD1
	rol	tBCD2
	dec	cnt16a	;decrement loop counter
	brne	bBCDx_2	;if counter not zero
	ret		;return
bBCDx_2:	ldi	r30,AtBCD2+1	;Z points to result MSB + 1
bBCDx_3:	ld	tmp16a,-Z	;get (Z) with pre-decrement
	subi	tmp16a,-$03	;add 0x03
	sbrc	tmp16a,3	;if bit 3 not clear
	st	Z,tmp16a	;store back
	ld	tmp16a,Z	;get (Z)
	subi	tmp16a,-$30	;add 0x30
	sbrc	tmp16a,7	;if bit 7 not clear
	st	Z,tmp16a	;store back
	cpi	ZL,AtBCD0	;done all three?
	brne	bBCDx_3	;loop again if not
	rjmp	bBCDx_1
;*******************************************************************************************
;	Rutiny zpozdeni
;*******************************************************************************************	
;-------------------------------------------------------------------------------------------
;	nastavitelne zpozdeni (R16)
;-------------------------------------------------------------------------------------------
DelayLongVar:	clr	R0
	clr	R1
DelLvar:	dec	R1
	brne	DelLvar
	dec	R0
	brne	DelLvar
	dec	R16
	brne	DelLvar
	ret
;-------------------------------------------------------------------------------------------
;	nastavitelne kratke zpozdeni (R16)
;-------------------------------------------------------------------------------------------
DelayShortVar:	clr	R0
DelSvar:	dec	R0
	brne	DelSvar
	dec	R16
	brne	DelSvar
	ret
;**********************************************************************************************
;tabulka jednotlivych podporovanych formatu pro PCM WAV
;format: pocet kanalu, low(samplerate), high(samplerate), pocet bitu na vzorek (jen 16), 
;konstanta pro timer 0 ((XTAL/8)/samplerate-1), konstanta pro rychlost rolovani textu
;**********************************************************************************************
	 
FormatT:	;11025Hz, mono, 16 bit
	.db	1,low(11025),high(11025),16,((XTAL/8)/11025)-1,((NameRollSpeed*11025)/22050)/2
	;11025Hz, stereo, 16 bit
	.db	2,low(11025),high(11025),16,((XTAL/8)/11025)-1,(NameRollSpeed*11025)/22050
	;12000Hz, mono, 16 bit 
	.db	1,low(12000),high(12000),16,((XTAL/8)/12000)-1,((NameRollSpeed*12000)/22050)/2
	;12000Hz, stereo, 16 bit
	.db	2,low(12000),high(12000),16,((XTAL/8)/12000)-1,(NameRollSpeed*12000)/22050
	;16000Hz, mono, 16 bit 
	.db	1,low(16000),high(16000),16,((XTAL/8)/16000)-1,((NameRollSpeed*16000)/22050)/2
	;16000Hz, stereo, 16 bit
	.db	2,low(16000),high(16000),16,((XTAL/8)/16000)-1,(NameRollSpeed*16000)/22050
	;22050Hz, mono, 16 bit 
	.db	1,low(22050),high(22050),16,((XTAL/8)/22050)-1,((NameRollSpeed*22050)/22050)/2
	;22050Hz, stereo, 16 bit
	.db	2,low(22050),high(22050),16,((XTAL/8)/22050)-1,(NameRollSpeed*22050)/22050
	;24000Hz, mono, 16 bit 
	.db	1,low(24000),high(24000),16,((XTAL/8)/24000)-1,((NameRollSpeed*24000)/22050)/2
	;24000Hz, stereo, 16 bit
	.db	2,low(24000),high(24000),16,((XTAL/8)/24000)-1,(NameRollSpeed*24000)/22050
	;32000Hz, mono, 16 bit 
	.db	1,low(32000),high(32000),16,((XTAL/8)/32000)-1,((NameRollSpeed*32000)/22050)/2
	;32000Hz, stereo, 16 bit
	.db	2,low(32000),high(32000),16,((XTAL/8)/32000)-1,(NameRollSpeed*32000)/22050
	;44100Hz, mono, 16 bit 
	.db	1,low(44100),high(44100),16,((XTAL/8)/44100)-1,((NameRollSpeed*44100)/22050)/2
	;44100Hz, stereo, 16 bit
	.db	2,low(44100),high(44100),16,((XTAL/8)/44100)-1,(NameRollSpeed*44100)/22050
	;48000Hz, mono, 16 bit 
	.db	1,low(48000),high(48000),16,((XTAL/8)/48000)-1,((NameRollSpeed*48000)/22050)/2
	;48000Hz, stereo, 16 bit
	.db	2,low(48000),high(48000),16,((XTAL/8)/48000)-1,(NameRollSpeed*48000)/22050
	.db	0xFF,0xFF	;konec tabulky

;*******************************************************************************************
;	texty, 0xFF zakonceni vypisu, 0x00 zalomi radek
;*******************************************************************************************	
TextStereoT:	.db	"stereo",0xFF
TextMonoT:	.db	"mono  ",0xFF
TextBitT:	.db	"bit",0xFF
TextHzT:	.db	"Hz",0xFF
TextSkladebT:	.db	"Skladeb: ",0xFF
TextNoFoldT:	.db	"V root nejsou zadne",0x00,"adresare",0xFF
